#!/usr/local/bin/perl
# SQUARE ENIX CROSSGATẼOt@CScenarioTalk`xmlɕϊ
# ver 0.01
# 蔲:p
#
# XV
# 2003/08/25	0.01
# 	VK쐬

use strict;
use File::Spec;

main();
exit(0);

sub main()
{
	for(@ARGV){
		chomp;
		$_ = trim($_);
		next if($_ eq "");
		xglog2xml($_);
	}
}

sub xglog2xml
{
	my($infile) = @_;
	my($fCast) = 0;
	my(%hCast) = ("-----", 0);
	my($CastCnt) = 1;
	my($SerifCnt) = 0;
	my(%hSerif) = ();
	my($fBr) = 0;	# stO
	my($cast, $serif, $serif_memo) = ("", "", "");
	my($outfile) = substr($infile, 0, rindex($infile, ".")) . ".xml";	# o̓t@C

	open(I_FILE, "<" . $infile) or die "Can't open file [$infile]\n";
	open(O_FILE, ">" . $outfile) or die "Can't open file [$outfile]\n";
	my($oldfh) = select(O_FILE);
	$| = 1;

	my($title, $memo) = getTitle($infile);

	while(<I_FILE>){
		chomp;
		next if(/^>>|^--/);	# 擪">>" or "--"̍s͖

		if(length($_) >= 68){	# 1s68ȏゾƁAsɕĂ\
			$fBr = 1;
		}else{
			$fBr = 0;
		}

		$_ = trim($_);
		$_ = encodeXml($_);
		if($_ eq ""){
			$fCast = 0;
			$serif = $serif_memo = "";
			next;
		}
		
		if(/^/){	#  ̓OCȂ̂ňꉞ荞
			$fCast = 0;
			$serif = $_;
			$serif_memo = "";
		}
		
		if(/^\d+:\d+:\d+@/){
			my($tmp) = $';
			if(substr($tmp, 0, 2) eq "@" && !$fBr){ # sɕĂZt
				my($_c, $_s, $_m) = split(/\t/, $hSerif{$SerifCnt-1});
				$_s .= substr($tmp, 2);
				$hSerif{$SerifCnt-1} = $_c . "\t" . $_s . "\t" . $_m;
				next;
			}
			if($tmp =~ /^([^:]+): /){	# Oo
				$serif = $';# Zt
				$fCast = 1;
				$cast = trim($1);
				$serif_memo = "";
				if($cast =~ /^(\[[^\]]+\])/){	# [GP]Ƃ[MIC]Ƃ
					$serif_memo = $1;
					$cast = $';
				}
				if($cast ne "" && $hCast{$cast} eq ""){
					$hCast{$cast} = $CastCnt;
					$CastCnt++;
				}
			}else{
				# ȊO̍s
				# c[͂܂
				# cOAEgăOCQ[gɖ߂܂
				# Ȃ
				next;
			}
		}

		unless($fCast){
			$cast = "-----";
		}
		
		# Zt荞
		$hSerif{$SerifCnt} = $hCast{$cast} . "\t" . $serif . "\t" . $serif_memo;
		$SerifCnt++;
	}

	print <<EOF;
<?xml version="1.0" encoding="Shift_JIS"?>
<script version="1.0">
	<title>
	$title
	</title>
	<memo>
	$memo
	</memo>
EOF

	for(sort{$hCast{$a} <=> $hCast{$b}} keys(%hCast)){
		print <<"EOF";
	<cast>
		<cast_id>
			$hCast{$_}
		</cast_id>
		<name>
			$_
		</name>
		<memo>
			
		</memo>
	</cast>
EOF
	}

	for(sort {$a <=> $b} keys(%hSerif)){
		my($cast_id, $serif, $lmemo) = split(/\t/,$hSerif{$_});
		print <<"EOF";
	<serif>
		<cast_id>
			$cast_id
		</cast_id>
		<serif>
			$serif
		</serif>
		<memo>
			$lmemo
		</memo>
	</serif>
EOF
	}


	print <<"EOF";
</script>
EOF

	select($oldfh);
	close(I_FILE);
	close(O_FILE);
}


sub getTitle()
{
	my($infile) = @_;
	my($title, $memo) = ("", "");
	$title = $infile;	# ^Cg̓t@CɂĂ
	return ($title, $memo);
}

# Ő󔒁A^u폜
sub trim{
	my($str) = @_;
	$str =~ s/^[\t\s]*|[\t\s]*$//g;
	return $str;
}

# XMLGR[h
sub  encodeXml
{
	my($str) = @_;
	
	$str =~ s/&/&amp;/g;
	$str =~ s/"/&quot;/g;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/'/&apos;/g;
	
	return $str;
}